<?php namespace Kliken\WpPlugin;

use Httpful\Exception\ConnectionErrorException;
use Httpful\Request;
use Kliken\Exception\KK_Api_Exception;

defined( 'ABSPATH' ) or die( 'No script kiddies please!' );

class KK_Api
{
	public static function get_account( $api_token, $user_token ) {
		$response = Request::get( KK_REPORTING_API_URL . 'account/getaccount' )
			->addHeader( 'AccountAuth', base64_encode( "{$api_token}:{$user_token}" ) )
			->expectsJson()
			->send();

		if ( $response->code !== 200 ) {
			throw new KK_Api_Exception( $response->raw_body );
		}

		// Returned JSON will be detected automatically and decoded into "body" property
		return $response->body;
	}

	public static function get_account_from_invitation( $api_token, $invitation_code ) {
		$response = Request::post( KK_REST_API_URL . 'auth/invite' )
			->sendsJson()
			->body( json_encode( array( 'AccountToken' => $api_token, 'Code' => $invitation_code ) ) )
			->expectsJson()
			->send();

		if ( $response->code !== 200 ) {
			throw new KK_Api_Exception( $response->raw_body );
		}

		return $response->body;
	}
}
