<?php

/*
Plugin Name: Kliken All-In-One Marketing
Plugin URI: http://kliken.com
Description: Kliken is a DIY online marketing platform. Start with FREE website analytics and SEO keyword ranking.
Version: 1.4.2
Author: SiteWit
Author URI: http://kliken.com
Text Domain: kliken-all-in-one-marketing
Domain path: /languages
License: GPLv2 or later
*/

// This plugin use PHP 5.3 features, so need to exit right away if the PHP version of the host is < 5.3
define( 'KK_PHP_MIN_VERSION', '5.3.0' );
if ( version_compare( PHP_VERSION, KK_PHP_MIN_VERSION, '<' ) ) {
	if ( is_admin() ) {
		exit( 'You are using PHP version ' . PHP_VERSION . '. This plugin requires PHP version 5.3 and later!' );
	}
}

defined( 'ABSPATH' ) or die( 'No script kiddies please!' );

define( 'KK_PLUGIN_SCHEMA_VERSION', '3' );
define( 'KK_PLUGIN_FILE', __FILE__ );
define( 'KK_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
define( 'KK_PLUGIN_URL', plugin_dir_url( __FILE__ ) );
define( 'KK_NAMESPACE', 'Kliken\WpPlugin' );
define( 'KK_SETTING_PAGE', 'klikenconfig' );
define( 'KK_HOST', 'https://my.kliken.com/' );
define( 'KK_REPORTING_API_URL', 'https://reporting.sitewit.com/api/' );
define( 'KK_REST_API_URL', 'https://rest.sitewit.com/api/' );

// Text Domain for internationalization. MUST match plugin slug!
// Change this and also change the Text Domain in the header above.
define( 'KK_TEXT_DOMAIN', 'kliken-all-in-one-marketing' );

define( 'KK_OPTION_NAME_TRACKING_SCRIPT', 'kk_tracking_script' );
define( 'KK_OPTION_NAME_AFFILIATE_ID', 'kk_affiliate_id' );
define( 'KK_OPTION_NAME_SCHEMA_VERSION', 'kk_schema_version' );
define( 'KK_OPTION_NAME_INVITATION_CODE', 'kk_invitation_code');
define( 'KK_OPTION_NAME_API_TOKEN', 'kk_api_token');

// Support for internationalization
load_plugin_textdomain( KK_TEXT_DOMAIN, false, basename( dirname( __FILE__ ) ) . '/languages' );

// This should contain all the checks to ensure the plugin will operate properly.
function kk_activation_check() {
	// Check for cURL extension availability so we can connect to our API
	if ( ! function_exists( 'curl_init' ) ) {
		wp_die( __( 'This plugin requires cURL PHP extension to be enabled. Please contact your hosting provider to enable it.', KK_TEXT_DOMAIN ) );
	}

	// Check if the site already has tracking code injected by cPanel
	// Parsing the .htaccess file and find the inject code. Need test to make sure we can read the .htaccess file.
	$htaccess_file = get_home_path() . '.htaccess';
	if ( true === file_exists( $htaccess_file ) ) {
		$content = file_get_contents( $htaccess_file );
		if ( false !== strpos( $content, "AddOutputFilterByType SUBSTITUTE text/html" )
		     && 1 === preg_match('/sitewit.com\/v3\/\d+\/sw\.js/', $content) )
		{
			wp_die( __( 'This site seems to already have tracking code injected by cPanel. Please go to cPanel for Kliken Reports.', KK_TEXT_DOMAIN ) );
	    }
	}
}

function kk_deactivation_check() {
    kk_plugin_db_cleanup( false );
}

function kk_uninstallation_check() {
    kk_plugin_db_cleanup(true);
}

register_activation_hook( __FILE__, 'kk_activation_check' );
register_deactivation_hook( __FILE__, 'kk_deactivation_check' );
register_uninstall_hook( __FILE__, 'kk_uninstallation_check' );

require_once 'init.php';
